import oauthserver from 'oauth2-server';
import { Model } from './model';
export class OAuthHandler {    
    app:any;
    getAuthProvider(){
        return this.app.oauth;
    }    
    private create(app:any, modalStore:Model, context:string){
        let oauth:any = oauthserver({
            model: modalStore,
            grants: ["password", "refresh_token", "client_credentials", "authorization_code"],//['password', 'refresh_token'],
            debug: true,
            
            //accessTokenLifetime: Model.JWT_ACCESS_TOKEN_EXPIRY_SECONDS,   // expiry time in seconds, consistent with JWT setting in model.js
            //refreshTokenLifetime: Model.JWT_REFRESH_TOKEN_EXPIRY_SECONDS   // expiry time in seconds, consistent with JWT setting in model.js
        });
        oauth.regex.clientId = '[A-Fa-f0-9]{3,64}';
        var grantCart = ()=>{
            let grant = app.oauth.grant();
            return (req, res, next)=>{
                modalStore.findCredentials(req);
                grant(req, res, next);
              };
        }
        app.oauth = oauth;
        app.post(context+'/oauth/token', grantCart());
        app.use(oauth.errorHandler());
    }
    findAuthorize(app:any){
        let authorise = app.oauth.authorise();
        return (req, res, next)=>{
            let wReq:any = Object.create(req);
            wReq.get =
            wReq.header = function header(name) {
                var lc = name.toLowerCase();
                if(lc === 'authorization'){
                    if(req.get('tharak-auth'))
                        return req.get('tharak-auth');
                    else
                        return req.get(lc);
                }else{
                    return req.get(name);
                }
            };
            authorise(wReq, res, next);
        };
    }
    getAppId(bearerToken, callback){
        Model.getAppId(bearerToken, callback);
    }
    addHandler(config:any){
        this.app = config.app;
        let modalStore = new Model(config.clientConfig, config.dispatcher, config.util);
        this.create(this.app, modalStore, config.clientConfig.serviceContext);
    }
    addHandler2(config:any){
        this.app = config.app;
        let modalStore = new Model(config.apps, config.dispatcher, config.util);
        config.apps.forEach((app:any)=>{
            this.create(this.app, modalStore, app.serviceContext);
        });
    }
    addHandler3(config:any){
        this.app = config.app;
        let modalStore = new Model(config.apps, config.dispatcher, config.util);
        config.apps.forEach((app:any)=>{
            this.create(this.app, modalStore, config.defAppId+app.serviceContext);
        });
    }
    onInit(config:any){
        if(!config)
            return;        
    } 
}
